import abc
import asyncio
from ..core.base import AbstractReader as AbstractReader, AbstractWriter as AbstractWriter
from ..utils import import_name as import_name
from typing import Any

class AbstractQueue(AbstractReader, AbstractWriter, metaclass=abc.ABCMeta): ...

class Queue(asyncio.Queue, AbstractQueue):
    def __init__(self, config: Any | None = ..., *, loop: Any | None = ..., **kwargs) -> None: ...
    def set_config(self, config) -> None: ...
    def __len__(self): ...

class PriorityQueue(asyncio.PriorityQueue, Queue):
    def __init__(self, config: Any | None = ..., *, loop: Any | None = ..., **kwargs) -> None: ...

class ScoreQueueMixin:
    def __init__(self, *args, **kwargs): ...
    def set_config(self, config) -> None: ...
    def put(self, value, score: Any | None = ...): ...
    async def get(self, score: bool = ...): ...

def score_queue(default_score: Any | None = ...): ...

class ScoreQueue(PriorityQueue): ...
